scala

# Enumeration

#### abstract class Enumeration extends Serializable

Defines a finite set of values specific to the enumeration. Typically these values enumerate all possible forms something can take and provide a lightweight alternative to case classes.

Each call to a `Value` method adds a new unique value to the enumeration. To be accessible, these values are usually defined as `val` members of the evaluation.

All values in an enumeration share a common, unique type defined as the `Value` type member of the enumeration (`Value` selected on the stable identifier path of the enumeration instance).

Self Type
  Enumeration
Annotations
  @SerialVersionUID( uid = 8476000850333817230L )
Source
  Enumeration.scala
Example:

1.     object Main extends App {

         object WeekDay extends Enumeration {
           type WeekDay = Value
           val Mon, Tue, Wed, Thu, Fri, Sat, Sun = Value
         }
         import WeekDay._

         def isWorkingDay(d: WeekDay) = ! (d == Sat || d == Sun)

         WeekDay.values filter isWorkingDay foreach println
       }
       // output:
       // Mon
       // Tue
       // Wed
       // Thu
       // Fri

Linear Supertypes
Serializable, java.io.Serializable, AnyRef, Any
Known Subclasses
Alignment, Alignment, Anchor, AutoResizeMode, BarPolicy, ElementMode, Fill, FocusLostBehavior, IntervalMode, IntervalMode, Key, Layout, Location, Message, MinimizeMode, Options, Orientation, Position, Result, Result, RoundingMode, SelectionMode, State
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Enumeration
2. Serializable
3. Serializable
4. AnyRef
5. Any

Implicitly

1. by any2stringadd
2. by any2stringfmt
3. by any2ArrowAssoc
4. by any2Ensuring

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Instance Constructors

1. #### new Enumeration()

2. #### new Enumeration(initial: Int)

   initial

     The initial value from which to count the integers that identifies values at run-time.

3. #### new Enumeration(names: String*)

   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) Names should be specified individually or discovered via reflection

4. #### new Enumeration(initial: Int, names: String*)

   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) Names should be specified individually or discovered via reflection

### Type Members

1. #### class Val extends Value with Serializable

   A class implementing the scala.Enumeration.Value type.

2. #### abstract class Value extends Ordered[Value] with Serializable

   The type of the enumerated values.

3. #### class ValueSet extends AbstractSet[Value] with SortedSet[Value] with SortedSetLike[Value, ValueSet] with Serializable

   A class for sets of values.

### Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

3. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

4. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from Enumeration to StringAdd performed by method any2stringadd in scala.Predef.
   Definition Classes
     StringAdd

5. #### def ->[B](y: B): (Enumeration, B)

   Implicit information
     This member is added by an implicit conversion from Enumeration to ArrowAssoc[Enumeration] performed by method any2ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

6. #### final def ==(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

7. #### final def ==(arg0: Any): Boolean

   Test two objects for equality.

   Test two objects for equality. The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     Any

8. #### final def Value(i: Int, name: String): Value

   Creates a fresh value, part of this enumeration, called `name` and identified by the integer `i`.

   Creates a fresh value, part of this enumeration, called `name` and identified by the integer `i`.

   i

     An integer that identifies this value at run-time. It must be unique amongst all values of the enumeration.

   name

     A human-readable name for that value.

   returns

     Fresh value with the provided identifier `i` and name `name`.

   Attributes
     protected

9. #### final def Value(name: String): Value

   Creates a fresh value, part of this enumeration, called `name`.

   Creates a fresh value, part of this enumeration, called `name`.

   name

     A human-readable name for that value.

   returns

     Fresh value called `name`.

   Attributes
     protected

10. #### final def Value(i: Int): Value

    Creates a fresh value, part of this enumeration, identified by the integer `i`.

    Creates a fresh value, part of this enumeration, identified by the integer `i`.

    i

      An integer that identifies this value at run-time. It must be unique amongst all values of the enumeration.

    returns

      Fresh value identified by `i`.

    Attributes
      protected

11. #### final def Value: Value

    Creates a fresh value, part of this enumeration.

    Creates a fresh value, part of this enumeration.

    Attributes
      protected

12. #### object ValueOrdering extends Ordering[Value]

    An ordering by id for values of this set

13. #### object ValueSet extends Serializable

    A factory object for value sets

14. #### final def apply(x: Int): Value

    The value of this enumeration with given id `x`

15. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown
      ClassCastException

      if the receiver object is not an instance of the erasure of type `T0`.

16. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

17. #### def ensuring(cond: (Enumeration) ⇒ Boolean, msg: ⇒ Any): Enumeration

    Implicit information
      This member is added by an implicit conversion from Enumeration to Ensuring[Enumeration] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

18. #### def ensuring(cond: (Enumeration) ⇒ Boolean): Enumeration

    Implicit information
      This member is added by an implicit conversion from Enumeration to Ensuring[Enumeration] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

19. #### def ensuring(cond: Boolean, msg: ⇒ Any): Enumeration

    Implicit information
      This member is added by an implicit conversion from Enumeration to Ensuring[Enumeration] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

20. #### def ensuring(cond: Boolean): Enumeration

    Implicit information
      This member is added by an implicit conversion from Enumeration to Ensuring[Enumeration] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

21. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

22. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

23. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

24. #### def formatted(fmtstr: String): String

    Returns string formatted according to given `format` string.

    Returns string formatted according to given `format` string. Format strings are as for `String.format` (@see java.lang.String.format).

    Implicit information
      This member is added by an implicit conversion from Enumeration to StringFormat performed by method any2stringfmt in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

25. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

26. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

27. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

28. #### final def maxId: Int

    The one higher than the highest integer amongst those used to identify values in this enumeration.

29. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

30. #### var nextId: Int

    The integer to use to identify the next created value.

    The integer to use to identify the next created value.

    Attributes
      protected

31. #### var nextName: Iterator[String]

    The string to use to name the next created value.

    The string to use to name the next created value.

    Attributes
      protected

32. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

33. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

34. #### def readResolve(): AnyRef

    Attributes
      protected

35. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

36. #### def toString(): String

    The name of this enumeration.

    The name of this enumeration.

    returns

      a String representation of the object.

    Definition Classes
      Enumeration → AnyRef → Any

37. #### def values: ValueSet

    The values of this enumeration as a set.

38. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

39. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

40. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

41. #### final def withName(s: String): Value

    Return a `Value` from this `Enumeration` whose name matches the argument `s`.

    Return a `Value` from this `Enumeration` whose name matches the argument `s`. The names are determined automatically via reflection.

    s

      an `Enumeration` name

    returns

      the `Value` of this `Enumeration` if its name matches `s`

    Exceptions thrown
      java.util.NoSuchElementException

      if no `Value` with a matching name is in this `Enumeration`

42. #### def →[B](y: B): (Enumeration, B)

    Implicit information
      This member is added by an implicit conversion from Enumeration to ArrowAssoc[Enumeration] performed by method any2ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Shadowed Implicit Value Members

1. #### val self: Any

   Implicit information
     This member is added by an implicit conversion from Enumeration to StringAdd performed by method any2stringadd in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (enumeration: StringAdd).self

   Definition Classes
     StringAdd

2. #### val self: Any

   Implicit information
     This member is added by an implicit conversion from Enumeration to StringFormat performed by method any2stringfmt in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (enumeration: StringFormat).self

   Definition Classes
     StringFormat

### Deprecated Value Members

1. #### def x: Enumeration

   Implicit information
     This member is added by an implicit conversion from Enumeration to ArrowAssoc[Enumeration] performed by method any2ArrowAssoc in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (enumeration: ArrowAssoc[Enumeration]).x

   Definition Classes
     ArrowAssoc
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) Use `leftOfArrow`instead``

2. #### def x: Enumeration

   Implicit information
     This member is added by an implicit conversion from Enumeration to Ensuring[Enumeration] performed by method any2Ensuring in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (enumeration: Ensuring[Enumeration]).x

   Definition Classes
     Ensuring
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) Use `resultOfEnsuring`instead``

### Inherited from Serializable

### Inherited from java.io.Serializable

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from Enumeration to StringAdd

### Inherited by implicit conversion any2stringfmt from Enumeration to StringFormat

### Inherited by implicit conversion any2ArrowAssoc from Enumeration to ArrowAssoc[Enumeration]

### Inherited by implicit conversion any2Ensuring from Enumeration to Ensuring[Enumeration]

### Ungrouped